
#ifndef CONTROLLER_H_
#define CONTROLLER_H_

#ifdef __cplusplus
extern "C" {
#endif

	#include <ardrone_tool/UI/ardrone_input.h>

	#ifdef GLOBAL_DEFINE_KEYBOARD

		C_RESULT open_dx_keyboard(void);
		C_RESULT update_dx_keyboard(void);
		C_RESULT close_dx_keyboard(void);

		input_device_t dx_keyboard = {
			"DirectX Keyboard",
			open_dx_keyboard,
			update_dx_keyboard,
			close_dx_keyboard
		};

	#else
		extern input_device_t dx_keyboard;
	#endif

#ifdef __cplusplus
}
#endif

#endif // CONTROLLER_H_
