

#include "converter.h"

static IplImage *g_imgDrone = NULL;	// AR.DronẽJ摜


// AR.DronẽJ摜Ɋւ鏉
void InitDroneCamera(void)
{
	g_imgDrone = NULL;
}


// AR.DRonẽJ摜擾
IplImage * GetDroneCameraImage(void)
{
	return g_imgDrone;
}


// AR.DronẽJ摜ɊւI
void ReleaseDroneCamera(void)
{
	cvReleaseImage(&g_imgDrone);
	g_imgDrone = NULL;
}


// obt@IplImageւ̕ϊ
void ConvertImage( unsigned char *buffer_image, int buffer_image_width, int buffer_image_height, int image_width, int image_height )
{
	int x, y;
	unsigned char *p_src;
	char          *p_dst;

	if ( g_imgDrone == NULL || g_imgDrone->width != image_width || g_imgDrone->height != image_height ) {
		if (g_imgDrone!=NULL) cvReleaseImage(&g_imgDrone);
		g_imgDrone = cvCreateImage(cvSize(image_width,image_height),IPL_DEPTH_8U, 3);
	}

	for (y=0; y<g_imgDrone->height; y++) {
		for (x=0; x<g_imgDrone->width; x++) {

			p_src = buffer_image + y*3*buffer_image_width + 3*x;
			p_dst = g_imgDrone->imageData + y*g_imgDrone->widthStep + x*g_imgDrone->nChannels;

			p_dst[0] = p_src[2];	// b
			p_dst[1] = p_src[1];	// g
			p_dst[2] = p_src[0];	// r
		}
	}
}
